#ifndef    __kfish_h__
#define    __kfish_h__

#include <qstring.h>
#include <qimage.h>

#include <kpanelapplet.h>
#include <kapplication.h>
//#include <qapplitacion.h>
#include <qapplication.h> 
class QTimer;
class QCanvas;
class KAboutData;
class kfishCanvasView;
class fishSprite;
class kfishBubbleManager;
class configDlg;
class kfish;

extern kfish *kfishApp;
 
class kfish : public KPanelApplet
{
  Q_OBJECT

public:
    kfish(const QString& configFile, Type t = Stretch, int actions = 0, QWidget *parent = 0, const char *name = 0 );

    ~kfish(void);

    // Methods reimplemented from KPanelApplet
  
    int widthForHeight( int height ) const;
    int heightForWidth( int width ) const;
    void orientationChange(Orientation orient);

    void about(void);
    void preferences(void);
    
	QCanvas *getCanvas() const { return m_canvas; };
  
signals:
    void signalSettingsChanged();
  
protected slots:
    void slotSettingsChanged();
  
    void slotAbout();
    void slotPreferences();

    void slotConfigDlgDestroy();

 private:
    int m_oldwidth;

    kfishCanvasView    *m_canvasview;
    fishSprite         *m_fish;
    kfishBubbleManager *m_bubble;
    QCanvas            *m_canvas;
    configDlg          *confDlg;

};

//Can't use this, becouse this widget doesn't have any parent... he has been "abandonado" at his own luck!
//#define kfishapp (static_cast<kfish*>(kapp))   Any idea how to do this?

#endif
